// gStack class

template <class iTyp>
G::Stack<iTyp>::Stack()
{
	iSize = 0;
	head = NULL;
}

template <class iTyp>
G::Stack<iTyp>::Stack(const Stack<iTyp> &s)
{
	gStackNode<iTyp> *i;
	gStackNode<iTyp> *newitem;
	int x;

	head = NULL;
	end = NULL;
	iSize = s.iSize;
	
	if (s.head != NULL)
	{
		i = s.head;
		for (x = 0; x < iSize; x++)
		{
			newitem = AddNode();
			newitem->item = i->item;
			i = i->next;
		}
		end = newitem;
	}
}

template <class iTyp>
G::Stack<iTyp>::~Stack()
{
	gStackNode<iTyp> *item;
	gStackNode<iTyp> *lastitem;
	// Go through and remove all the elements in the stack
	if (head != NULL)
	{
		item = head;
		while (item != NULL)
		{
			lastitem = item;
			item = item->next;
			delete lastitem;
		}
		//delete lastitem;
	}
}

template <class iTyp>
int G::Stack<iTyp>::size()
{
	return iSize;
}

template <class iTyp>
void G::Stack<iTyp>::push(const iTyp i)
{
	gStackNode<iTyp> *newitem;
	// Add a new node
	newitem = AddNode();
	newitem->item = i;
}

template <class iTyp>
bool G::Stack<iTyp>::pop(iTyp &i)
{
	gStackNode<iTyp> *topitem;
	
	if (head == NULL) return false;

	topitem = head;
	i = topitem->item;
	head = head->next;
	delete topitem;
	iSize--;

	return true;
}

template <class iTyp>
void G::Stack<iTyp>::flush()
{
	gStackNode<iTyp> *item;
	gStackNode<iTyp> *lastitem;
	if (head != NULL)
	{
		item = head;
		while (item != NULL)
		{
			lastitem = item;
			item = item->next;
			delete lastitem;
		}
		delete lastitem;
	}
	iSize = 0;
}

template <class iTyp>
G::gStackNode<iTyp> *G::Stack<iTyp>::AddNode()
{
	gStackNode<iTyp> *temp = new gStackNode<iTyp>;
	
	if (head != NULL)
	{
		temp->next = head;
		head = temp;
	}
	else
	{
		head = temp;
		head->next = NULL;
	}
	iSize++;

	return temp;
}